package me.hammerle.exceptions;

import me.hammerle.code.Script;

public class SnuviException extends RuntimeException
{
    private final Exception ex;
    private final String scriptName;
    private final String code;
    private final int line;
    
    public SnuviException(Exception ex, String scriptName, int line, String code)
    {
        this.ex = ex;
        this.scriptName = scriptName;
        this.code = code;
        this.line = line;
    }
    
    public SnuviException(Exception ex, String scriptName, String code)
    {
        this(ex, scriptName, -1, code);
    }
    
    public SnuviException(Exception ex, String scriptName, int line)
    {
        this(ex, scriptName, line, null);
    }
    
    public SnuviException(Exception ex, Script sc)
    {
        this(ex, sc.getName(), sc.getActiveCodeLine());
    }
    
    public Exception getOriginalException()
    {
        return ex;
    }
    
    public int getLine()
    {
        return line;
    }
    
    public String getCode()
    {
        return code;
    }
    
    public String getScriptName()
    {
        return scriptName;
    }
}
