package me.hammerle.snuviscript;

import me.hammerle.code.Script;
import me.hammerle.code.SnuviParser;
import me.hammerle.exceptions.SnuviException;
import me.hammerle.code.ISnuviScheduler;

public class SnuviScript 
{
    public static void main(String[] args) 
    {
        SnuviParser parser = new SnuviParser((SnuviException ex) -> 
        {
            System.out.println("Exception " + ex);
            System.out.println(ex.getOriginalException());
            System.out.println(ex.getCode());
            System.out.println(ex.getLine());
            System.out.println(ex.getScriptName());
        }, new ISnuviScheduler() 
        {
            @Override
            public void scheduleTask(Runnable r) 
            {
                System.out.println("Schedule");
            }

            @Override
            public void scheduleTask(Runnable r, long delay) 
            {
                System.out.println("Schedule");
            }
        });
        parser.registerConsumer("debug", (o, sc) -> System.out.println(o[0]));
        
        parser.startScript(Script.class, "test", 
                "wusi = 5;\n" +
                "@test;\n" +
                "while(wusi < 10)\n" +
                "{\n" +
                "    wusi += 1;\n" +
                "    debug(wusi);\n" +
                "}\n" + 
                "if( wusi > 100) { term();}" +
                "debug(wusi); wusi += 5; goto(\"test\");", true);
    }   
}
